class Tabla_mesas extends React.Component {
  constructor(props) {
    super(props)
    this.state = {
      lista_mesas : [],
      hash : ""
    }
    this.obtener = this.obtener.bind(this)
    this.obtener()

  }
  obtener() {
    var comp = this;
    $.ajax({
        type:"POST",
        url:"https://www.tfg.carlosh.es/admin/api/obtener_mesas.php",
        data : {
          hash : comp.state.hash
        },
        success:function(datos){
             if(datos.hash != comp.state.hash){
               comp.setState({lista_mesas: datos.array});
             }
             comp.setState({hash: datos.hash});
             setTimeout(comp.obtener, 1500);
         },
         error:function(datos){
              setTimeout(comp.obtener, 1500);
              console.log(datos)
          },
         dataType : "json"
    })
  }


  render() {
    const listItems = this.state.lista_mesas.map((mesa) =>
      <Mesa info={mesa} padre= {this}/>
    );
    return <table style={{width: "100%"}} >
            <tr >
              <th>Mesas</th>
              <th>Estado</th>
              <th>Asignado a</th>
              <th>Acciones</th>
            </tr>
            {listItems}
            </table>
  }
}



class Mesa extends React.Component {
  constructor(props) {
    super(props)
  }

  render() {
    let est = "";
    let bg_color = "";
    let btn;
    let clave = this.props.info.clave == "" ? "" : <span class="badge badge-primary" onClick ={(e) => accederMesa(this.props.info.codigo, this.props.info.clave)}>clave: {this.props.info.clave}</span>

    switch (this.props.info.estado){
      case "1":
        est = "No disponible";
        bg_color  = " bg-danger" ;
        break;
      case "2":
        est = "Libre";
        bg_color  = " bg-success";
        break;
      case "3":
          est = "Ocupada";
          bg_color  = " bg-info";
          break;
      case "4":
          est =  <span class="badge badge-danger">Pendiente de recoger</span>
          bg_color  = " bg-warning";
    }

    btn =  <div class="btn-group">
            <button type="button" class="btn btn-light " onClick ={(e) => acciones(this.props.info.id, this.props.info.estado, this.props.info.nombre)}>
              <span class="fa fa-ellipsis-v	"></span>
            </button>
            </div>
    var icono_edit_user =  this.props.info.usuario_asignado != null ? <span className="fa fa-pencil" style={{cursor: "pointer"}}
                                                                      onClick ={(e) => editar_user(this.props.info.id)}></span> : "";

    return  <tr>
                <td>{this.props.info.nombre} - {this.props.info.codigo} <br/>
                {clave}
                </td>
                <td className = {bg_color}>{est}</td>
                <td>{this.props.info.usuario_asignado} { icono_edit_user } </td>
                <td>{btn}</td>
           </tr>
  }
}
ReactDOM.render(<Tabla_mesas />, document.getElementById('tabla'));

function acciones(id_mesa,estado,nombre_mesa){
  var btn_libre = ' <button class= "btn btn-success" onclick="liberar('+ id_mesa+')"   style="width:80%;height:100px;">Marcar como libre</button> <br> ';;
  var btn_noDisponible = ' <button class="btn btn-danger"  onclick="cambiarEstado('+ id_mesa+' , 1)" style="width:80%;height:100px;">Marcar como no disponible</button><br>';
  var btn_ocupar = '<button class="btn btn-info"  onclick="cambiarEstado('+ id_mesa+' , 3) " style="width:80%;height:100px;">Marcar como ocupada</button> <br>' ;
  var btn_recoger = '<button class="btn btn-warning" onclick="cambiarEstado('+ id_mesa+' , 4) " style="width:80%;height:100px;">Marcar como pendiente de recoger</button> <br>';
  var botones;
  switch(estado){
    case '1':
      botones = btn_libre;
      break;
    case '2':
      botones =  btn_noDisponible + btn_ocupar;
      break;
    case '3':
      botones =  btn_recoger;
      break;
    case '4':
      botones = btn_libre + btn_noDisponible;
      break;

  }
  $.confirm({
      title: "Editor mesa <b>" + nombre_mesa + "</b>",
      content: ' \
        <div class="text-center"> \
          '+botones+' \
        </div> \
      ',
      columnClass: 'large',
      buttons: {

          Cancelar: function () {
          }
      }
      });
}

function cambiarEstado(id_mesa2,nuevo_estado){
  var titulo;
  var btn_class;
  var btn_text;
  switch(nuevo_estado){
    case 1:
      titulo = "¿Seguro que quieres cambiar a estado no disponible la mesa?"
      btn_class = "btn-danger"
      btn_text  ="Marcar como no disponible"
      break;
    case 3:
      titulo = "¿Seguro que quieres cambiar a estado ocupada la mesa?"
      btn_class = "btn-info"
      btn_text  ="Ocupar"
      break;
    case 4:
      titulo = "¿Seguro que quieres cambiar a estado pendiente de recoger la mesa?"
      btn_class = "btn-warning"
      btn_text  ="Marcar para recoger"
      break;

  }
  $.confirm({
      title: titulo,
      content: '',
      columnClass: 'large',
      buttons: {
          formSubmit: {
              text: btn_text,
              btnClass: btn_class,
              action: function () {
                $.ajax({
                    type:"POST",
                    url:"https://www.tfg.carlosh.es/admin/api/editar_estado_mesa.php",
                    data:{
                          id_mesa: id_mesa2 ,
                          estado: nuevo_estado
                        },
                    success:function(datos){
                      $(".jconfirm")[0].remove();
                     },
                })
              }
          },
          Cancelar: function () {
          },
      }
      });


}


function liberar(id) {

    var clave_gen = '';
    var ref = 'ABCDEFGHIJKLMNPQRSTUVWXYZ123456789';
    for (var i=0; i<5; i++)
    {
    clave_gen += ref.charAt(Math.floor(Math.random()*ref.length));
    }
    $.confirm({
        title: 'Marcar como libre la mesa',
        content: '' +
        '<div class="form-group">' +
        'Clave: <br><input id="clave" type="text"  value="'+ clave_gen+'" class="form-control" required />' +
        'Empleado asignado: <br> '+ opciones_empleados +
        '</div>',
        columnClass: 'large',
        buttons: {
            formSubmit: {
                text: 'Marcar como libre',
                btnClass: 'btn-success',
                action: function () {
                  $.ajax({
                      type:"POST",
                      url:"https://www.tfg.carlosh.es/admin/api/editar_estado_mesa.php",
                      data:{
                            id_mesa: id ,
                            clave:$("#clave").val(),
                            id_empleado : $("#id_empleado").val(),
                            estado:2
                          },
                      success:function(datos){
                        $(".jconfirm")[0].remove();
                       },
                  })
                  //$("#formulario_editar").submit();
                }
            },
            Cancelar: function () {
                //close
            },
        }
        });
  }

  function editar_user(id){
    $.confirm({
        title: "Cambiar empleado asignado a mesa",
        content: 'Empleado asignado: <br> '+ opciones_empleados,
        columnClass: 'large',
        buttons: {
            formSubmit: {
                text: "Cambiar",
                btnClass: "btn-info",
                action: function () {
                  $.ajax({
                      type:"POST",
                      url:"https://www.tfg.carlosh.es/admin/api/editar_usuario_mesa.php",
                      data:{
                            id_mesa: id ,
                            id_empleado : $("#id_empleado").val(),
                          },
                      success:function(datos){
                        $(".jconfirm")[0].remove();
                       },
                  })
                }
            },
            Cancelar: function () {
            },
        }
        });
  }

  function accederMesa(mesa, clave){
    var win = window.open('https://www.tfg.carlosh.es/app/index.php?codigo=' + mesa+ '&clave=' + clave);
  //alert(mesa+ "    " + clave)
  }
